@echo off
setlocal enabledelayedexpansion
set /a "stato=0"

REM Cancella il file "tmp.ino.bin" se esiste
if exist "tmp.ino.bin" (
    del /q "tmp.ino.bin" >nul
)
if exist "tmp.bootloader.bin" (
    del /q "tmp.bootloader.bin" >nul
)
if exist "tmp.ino.partitions.bin" (
    del /q "tmp.ino.partitions.bin" >nul
)

copy /b /Y "*.ino.bin" "tmp.ino.bin" >nul
copy /b /Y "*.bootloader.bin" "tmp.bootloader.bin" >nul
copy /b /Y "*.ino.partitions.bin" "tmp.ino.partitions.bin" >nul


echo COM disponibili:
for /f "tokens=*" %%A in ('wmic path Win32_SerialPort get DeviceID') do (
        set "porta=%%A"
        if "!porta:~0,3!"=="COM" (
		echo %%A

		REM Estrai solo il nome della porta senza caratteri aggiuntivi
		for /f "delims=" %%A in ("!porta!") do (
    		   set "cleanPort=%%A"
		)

		echo Mi connetto...

		"./esptool.exe" --chip esp32s2 --port !cleanPort! --baud 115200  --before default_reset --after hard_reset write_flash  -z --flash_mode keep --flash_freq keep --flash_size keep 0x1000 "tmp.bootloader.bin" 0x8000 "tmp.ino.partitions.bin" 0xe000 "boot_app0.bin" 0x10000 "tmp.ino.bin" >nul 2>&1

		IF ERRORLEVEL 1 (
		    echo Ok, svegliato.
		    set /a "stato=1"
		) ELSE (
		    echo Ha gia' programmato!
		    set /a "stato=2"
		)
		
		if !stato!==1 (
			echo Programmo
			timeout /t 10 /nobreak >nul
			echo .
			"./esptool.exe" --chip esp32s2 --port !cleanPort! --baud 115200  --before default_reset --after hard_reset write_flash  -z --flash_mode keep --flash_freq keep --flash_size keep 0x1000 "tmp.bootloader.bin" 0x8000 "tmp.ino.partitions.bin" 0xe000 "boot_app0.bin" 0x10000 "tmp.ino.bin" >nul 2>&1


			IF ERRORLEVEL 1 (
    				echo Errore, stacca e riattacca l'USB, o e' altro dispositivo.
			) ELSE (
    				echo Fatto, ok.
			)
		)

		rem attende il refresh delle porte
		echo Attendi 5 secondi
		timeout /t 5 /nobreak >nul
	)
	set /a "stato=0"
)

REM Cancella il file "tmp.ino.bin" se esiste
if exist "tmp.ino.bin" (
    del /q "tmp.ino.bin" >nul
)
if exist "tmp.bootloader.bin" (
    del /q "tmp.bootloader.bin" >nul
)
if exist "tmp.ino.partitions.bin" (
    del /q "tmp.ino.partitions.bin" >nul
)



pause
